/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package mindex.processors;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import messif.algorithms.AlgorithmMethodException;
import messif.buckets.BucketErrorCode;
import messif.objects.LocalAbstractObject;
import messif.operations.data.DeleteOperation;
import messif.operations.data.TruncateOperation;
import mindex.MetricIndex;
import mindex.navigation.VoronoiLeafCell;

/**
 *
 * @author Vlastislav Dohnal, Masaryk University, Brno, Czech Republic, dohnal@fi.muni.cz
 */
public class TruncateOperationNavigationProcessor extends DataManipulationNavigationProcessor {

    /**
     * Create the truncate processor from a truncate operation and current M-Index settings.
     * @param operation
     * @param mIndex
     * @throws AlgorithmMethodException 
     */
    public TruncateOperationNavigationProcessor(TruncateOperation operation, MetricIndex mIndex) throws AlgorithmMethodException {
        super(false, operation, mIndex, new ArrayList<LocalAbstractObject>(0));
    }

    @Override
    protected void processObjectsOnLeaf(VoronoiLeafCell leaf, List<LocalAbstractObject> objects) throws AlgorithmMethodException {
        leaf.readLock();
        try {
            if (!leaf.isValid()) {
                return;
            }
            leaf.clearData();
        } finally {
            leaf.readUnLock();
        }
    } 

    @Override
    public void close() {
        operation.endOperation();
        super.close();
    }
}
